//+--------------------------------------------------------------------------------------------+
//|                                                               Check_SharedMemory.dll.mq4   |
//|                                                               Copyright  Zhunko           |
//| 30.03.2010 - 09.02.2014                                       vadim@zhunko.ru              |
//+--------------------------------------------------------------------------------------------+
//|             .           |
//|            .         |
//|            .|
//+--------------------------------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "vadim@zhunko.ru"
#property script_show_inputs
#property strict
#include <SharedMemory.mqh> //    "SharedMemory.dll".
//
//   .                      //
input int    Area            = 0;                       //  : MEMORY_GLOBAL   0    .
                                                        //                 MEMORY_TERMINAL 1    .
                                                        //                 MEMORY_WINDOW   2    .
input string InitPrefix      = "";                      //       . ..  
//     .
input int    UserGlobal      =  25;                     //         .
input int    UserTerminal    =  50;                     //         .
input int    UserWindow      = 100;                     //         .
//   .
input bool   CheckWriteRead  = false;                   //  /   . ..   4.         .
input bool   CheckWrite      = false;                   //     . ..    4,    4.
input bool   CheckRead       = false;                   //     . .. , ,     4.
input bool   CheckGeneral    = false;                   //   .
input bool   CheckProjection = false;                   //         .
input bool   CheckClose      = false;                   //       .
//   .
input string NamePrefix      = "Check";                 //         .
input string NameMemory0     = "CheckMemory0";          //    .     : "Global\"  "Local\".
input string NameMemory1     = "CheckMemory1";          //    .
input string NameMemory2     = "CheckMemory2";          //    .
input string NameMemory3     = "CheckMemory3";          //    .
input string NameMemory4     = "Memory4";               //    .
//  .
input int    Index           = -1;                      //    .
input int    StartByte       = 0;                       //      ,     .
input int    MemorySize      = 64000;                   //      .
//   .
input bool   bValue          = true;                    //   BOOL. 
input char   cValue          = 123;                     //   CHAR.
input uchar  ucValue         = 255;                     //   UNSIGNED CHAR.
input short  shValue         = 32100;                   //   SHORT.
input ushort ushValue        = 65535;                   //   UNSIGNED SHORT.
input int    nValue          = 2147012345;              //   INT.
input uint   uiValue         = 4294967295;              //   UNSIGNED INT.
input long   lValue          = 9223372036854775807;     //   LONG.
input ulong  ulValue         = 18446744073709551615;    //   UNSIGNED LONG.
input float  fValue          = 1234.5;                  //   FLOAT.
input double dValue          = 1234.56789012;           //   DOUBLE.
input string sValue0         = " = 1234.56789"; //   STRING.
input string sValue1         = " = 9876.54321"; //   STRING.
input string sValue2         = " !!!";         //   STRING.
input string sValue3         = " !";             //   STRING.
input string sValue4         = "  ";     //   STRING.
//
void OnStart()
 {
  int    i = 0;
  size_t stAddress = NULL;
  int    hMapping = NULL;
  int    hMapping1 = NULL;
  int    hMapping2 = NULL;
  int    hMapping3 = NULL;
  int    hMapping4 = NULL;
  int    nAdr = 0; //    .
  int    nSize0 = StringLen(sValue0);
  int    nSize1 = StringLen(sValue1);
  int    nSize2 = StringLen(sValue2);
  int    nSize3 = StringLen(sValue3);
  int    nSize4 = StringLen(sValue4);
  string sComment = "";
  string sHandleWindow = string(ChartGetInteger(ChartID(), CHART_WINDOW_HANDLE));
  string sPrefix = "";
  //   .
  bool   abOutArray[10] = {true, false, true, false, true, true, true, false, false, false};
  char   acOutArray[10] = {-128, -93, -70, -25, 0, 25, 56, 86, 96, 127};
  uchar  aucOutArray[10] = {0, 54, 75, 123, 150, 175, 199, 210, 230, 255};
  short  ashOutArray[10] = {-32768, -22210, -16789, -8765, 0, 4567, 8907, 16789, 22456, 32767};
  ushort aushOutArray[10] = {0, 1210, 3789, 4765, 50764, 12567, 18907, 35789, 45456, 65535};
  int    aiOutArray[10] = {-2147483648, -1147432001, -16789, -8765, 0, 4567, 8907, 16789, 1147432001, 2147483647};
  uint   auiOutArray[10] = {0, 4567, 8907, 16789, 65535, 130535, 2600535, 1147432001, 2147483647, 4294967295};
  long   alOutArray[10] = {-9223372036854775808, -4294967295, -16789, -8765, 0, 4567, 8907, 16789, 4294967295, 9223372036854775807};
  ulong  aulOutArray[10] = {0, 4567, 8907, 16789, 1147432001, 2147483647, 4294967295, 8294967295, 9223372036854775807, 18446744073709551615};
  float  afOutArray[10] = {-21474.3200112345, -11474.3200112345, -16.78912345, -876.512345, 0, 45671.2345612345, 890712.345678912, 167891.234567891, 1147432.00112345, 214743.200112345};
  double adOutArray[10] = {-21474.3200112345, -11474.3200112345, -16.78912345, -876.512345, 0, 45671.2345612345, 890712.345678912, 167891.234567891, 1147432.00112345, 214743.200112345};
  //   .
  bool   abIncArray[10] = {0};
  char   acIncArray[10] = {0};
  uchar  aucIncArray[10] = {0};
  short  ashIncArray[10] = {0};
  ushort aushIncArray[10] = {0};
  int    aiIncArray[10] = {0};
  uint   auiIncArray[10] = {0};
  long   alIncArray[10] = {0};
  ulong  aulIncArray[10] = {0};
  float  afIncArray[10] = {0};
  double adIncArray[10] = {0};
  //xxxx   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  switch(Area)
   {
    case MEMORY_GLOBAL:   sComment = "  : MEMORY_GLOBAL\n\n"; break;
    case MEMORY_TERMINAL: sComment = "  : MEMORY_TERMINAL\n\n"; break;
    case MEMORY_WINDOW:   sComment = "  : MEMORY_WINDOW\n\n"; break;
   }
  //xxxx      . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (Area == MEMORY_WINDOW)
   {//       !   
    if (InitPrefix == "") sPrefix = sHandleWindow;
    else sPrefix = sHandleWindow + "." + InitPrefix;
   }
  //xxxx  . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  MemoryInit(UserGlobal, UserTerminal, UserWindow);
  //xxxx  /   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckWriteRead)
   {//====   . ===============================================================================================================================================================================================
    hMapping = MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize); //  .
    sComment = sComment + " \"" + NameMemory0 + "\" . : " + string(hMapping) + "\n\n";
    Comment(sComment);
//    hMapping = MemoryOpenW(Area, sPrefix, Index, NameMemory0); //   .   .
//    sComment = sComment + " \"" + NameMemory0 + "\" . : " + hMapping + "\n\n";
//    Comment(sComment);
    //====  /   . =========================================================================================================================================================================================
    sComment = sComment + "   BOOL: (" + string(MemoryWriteBoolW(Area, sPrefix, Index, NameMemory0, StartByte, bValue)) + ")  " + string(bValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   BOOL:             " + string(MemoryReadBoolW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   CHAR: (" + string(MemoryWriteCharW(Area, sPrefix, Index, NameMemory0, StartByte, cValue)) + ")  " + string(cValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   CHAR:             " + string(MemoryReadCharW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED CHAR: (" + string(MemoryWriteUCharW(Area, sPrefix, Index, NameMemory0, StartByte, ucValue)) + ")  " + string(ucValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED CHAR:             " + string(MemoryReadUCharW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   SHORT: (" + string(MemoryWriteShortW(Area, sPrefix, Index, NameMemory0, StartByte, shValue)) + ")  " + string(shValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   SHORT:             " + string(MemoryReadShortW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED SHORT: (" + string(MemoryWriteUShortW(Area, sPrefix, Index, NameMemory0, StartByte, ushValue)) + ")  " + string(ushValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED SHORT:             " + string(MemoryReadUShortW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   INT: (" + string(MemoryWriteIntW(Area, sPrefix, Index, NameMemory0, StartByte, nValue)) + ")  " + string(nValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   INT:             " + string(MemoryReadIntW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED INT: (" + string(MemoryWriteUIntW(Area, sPrefix, Index, NameMemory0, StartByte, uiValue)) + ")  " + string(uiValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED INT:             " + string(MemoryReadUIntW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   LONG: (" + string(MemoryWriteLongW(Area, sPrefix, Index, NameMemory0, StartByte, lValue)) + ")  " + string(lValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   LONG:             " + string(MemoryReadLongW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED LONG: (" + string(MemoryWriteULongW(Area, sPrefix, Index, NameMemory0, StartByte, ulValue)) + ")  " + string(ulValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED LONG:             " + string(MemoryReadULongW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   FLOAT: (" + string(MemoryWriteFloatW(Area, sPrefix, Index, NameMemory0, StartByte, fValue)) + ")  " + string(fValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   FLOAT:             " + string(MemoryReadFloatW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   DOUBLE: (" + string(MemoryWriteDoubleW(Area, sPrefix, Index, NameMemory0, StartByte, dValue)) + ")  " + string(dValue) + "\n";
    Comment(sComment);
    sComment = sComment + "   DOUBLE:             " + string(MemoryReadDoubleW(Area, sPrefix, Index, NameMemory0, StartByte)) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   STRING (ANSI): (" + string(MemoryWriteStringUnicodeToAnsiW(Area, InitPrefix, Index, NameMemory0, StartByte, sValue0)) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING (ANSI):             \"" + string(MemoryReadStringAnsiToUnicodeW(Area, InitPrefix, Index, NameMemory0, StartByte, nSize0)) + "\"\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   STRING (UNICODE): (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, StartByte, sValue1)) + ")  \"" + sValue1 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING (UNICODE):             \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte, nSize1)) + "\"\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //====  / . ==============================================================================================================================================================================================
    sComment = sComment + "   BOOL: (" + string(MemoryWriteBoolArrayW(Area, sPrefix, Index, NameMemory0, StartByte, abOutArray, ArraySize(abOutArray), 0, ArraySize(abOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(abOutArray[i]) + ", ";
      else sComment = sComment + string(abOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   BOOL: (" + string(MemoryReadBoolArrayW(Area, sPrefix, Index, NameMemory0, StartByte, abIncArray, ArraySize(abIncArray), 0, ArraySize(abOutArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(abIncArray[i]) + ", ";
      else sComment = sComment + string(abIncArray[i]) + "}\n";
     }
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   CHAR: (" + string(MemoryWriteCharArrayW(Area, sPrefix, Index, NameMemory0, StartByte, acOutArray, ArraySize(acOutArray), 0, ArraySize(acOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(acOutArray[i]) + ", ";
      else sComment = sComment + string(acOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   CHAR: (" + string(MemoryReadCharArrayW(Area, sPrefix, Index, NameMemory0, StartByte, acIncArray, ArraySize(acIncArray), 0, ArraySize(acIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(acIncArray[i]) + ", ";
      else sComment = sComment + string(acIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED CHAR: (" + string(MemoryWriteUCharArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aucOutArray, ArraySize(aucOutArray), 0, ArraySize(aucOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aucOutArray[i]) + ", ";
      else sComment = sComment + string(aucOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED CHAR: (" + string(MemoryReadUCharArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aucIncArray, ArraySize(aucIncArray), 0, ArraySize(aucIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aucIncArray[i]) + ", ";
      else sComment = sComment + string(aucIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   SHORT: (" + string(MemoryWriteShortArrayW(Area, sPrefix, Index, NameMemory0, StartByte, ashOutArray, ArraySize(ashOutArray), 0, ArraySize(ashOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(ashOutArray[i]) + ", ";
      else sComment = sComment + string(ashOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   SHORT: (" + string(MemoryReadShortArrayW(Area, sPrefix, Index, NameMemory0, StartByte, ashIncArray, ArraySize(ashIncArray), 0, ArraySize(ashIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(ashIncArray[i]) + ", ";
      else sComment = sComment + string(ashIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED SHORT: (" + string(MemoryWriteUShortArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aushOutArray, ArraySize(aushOutArray), 0, ArraySize(aushOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aushOutArray[i]) + ", ";
      else sComment = sComment + string(aushOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED SHORT: (" + string(MemoryReadUShortArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aushIncArray, ArraySize(aushIncArray), 0, ArraySize(aushIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aushIncArray[i]) + ", ";
      else sComment = sComment + string(aushIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   INT: (" + string(MemoryWriteIntArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aiOutArray, ArraySize(aiOutArray), 0, ArraySize(aiOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aiOutArray[i]) + ", ";
      else sComment = sComment + string(aiOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   INT: (" + string(MemoryReadIntArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aiIncArray, ArraySize(aiIncArray), 0, ArraySize(aiIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aiIncArray[i]) + ", ";
      else sComment = sComment + string(aiIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED INT: (" + string(MemoryWriteUIntArrayW(Area, sPrefix, Index, NameMemory0, StartByte, auiOutArray, ArraySize(auiOutArray), 0, ArraySize(auiOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(auiOutArray[i]) + ", ";
      else sComment = sComment + string(auiOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED INT: (" + string(MemoryReadUIntArrayW(Area, sPrefix, Index, NameMemory0, StartByte, auiIncArray, ArraySize(auiIncArray), 0, ArraySize(auiIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(auiIncArray[i]) + ", ";
      else sComment = sComment + string(auiIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   LONG: (" + string(MemoryWriteLongArrayW(Area, sPrefix, Index, NameMemory0, StartByte, alOutArray, ArraySize(alOutArray), 0, ArraySize(alOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(alOutArray[i]) + ", ";
      else sComment = sComment + string(alOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   LONG: (" + string(MemoryReadLongArrayW(Area, sPrefix, Index, NameMemory0, StartByte, alIncArray, ArraySize(alIncArray), 0, ArraySize(alIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(alIncArray[i]) + ", ";
      else sComment = sComment + string(alIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   UNSIGNED LONG: (" + string(MemoryWriteULongArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aulOutArray, ArraySize(aulOutArray), 0, ArraySize(aulOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aulOutArray[i]) + ", ";
      else sComment = sComment + string(aulOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   UNSIGNED LONG: (" + string(MemoryReadULongArrayW(Area, sPrefix, Index, NameMemory0, StartByte, aulIncArray, ArraySize(aulIncArray), 0, ArraySize(aulIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aulIncArray[i]) + ", ";
      else sComment = sComment + string(aulIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   FLOAT: (" + string(MemoryWriteFloatArrayW(Area, sPrefix, Index, NameMemory0, StartByte, afOutArray, ArraySize(afOutArray), 0, ArraySize(afOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(afOutArray[i]) + ", ";
      else sComment = sComment + string(afOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   FLOAT: (" + string(MemoryReadFloatArrayW(Area, sPrefix, Index, NameMemory0, StartByte, afIncArray, ArraySize(afIncArray), 0, ArraySize(afIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(afIncArray[i]) + ", ";
      else sComment = sComment + string(afIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   DOUBLE: (" + string(MemoryWriteDoubleArrayW(Area, sPrefix, Index, NameMemory0, StartByte, adOutArray, ArraySize(adOutArray), 0, ArraySize(adOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(adOutArray[i]) + ", ";
      else sComment = sComment + string(adOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   DOUBLE: (" + string(MemoryReadDoubleArrayW(Area, sPrefix, Index, NameMemory0, StartByte, adIncArray, ArraySize(adIncArray), 0, ArraySize(adIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(adIncArray[i]) + ", ";
      else sComment = sComment + string(adIncArray[i]) + "}\n\n";
     }
    Comment(sComment);
    //====   . ===============================================================================================================================================================================================
    sComment = sComment + " : (" + string(MemoryCloseHandleW(Area, sPrefix, hMapping)) + ")\n";
    Comment(sComment);
    sComment = sComment + " .   . : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory0)) + "\n\n"; //    .
    Comment(sComment);
    //        .        .
   }
  //xxxx   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckWrite)
   {//====         . ==========================================================================================================================================================
    stAddress = MemoryCreateProjectionW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize);
    sComment = sComment + " \"" + NameMemory0 + "\" . : " + string(stAddress) + "\n";
    Comment(sComment);
    sComment = sComment + "     0: " + MemoryFullNameByIndexW(Area, sPrefix, 0) + "\n";
    Comment(sComment);
//    sComment = sComment + "    . : " + MemoryOpenProjectionW(Area, sPrefix, Index, NameMemory0) + "\n\n";
//    Comment(sComment);
    sComment = sComment + "   : " + string(MemoryClearW(Area, sPrefix, Index, NameMemory0)) + "\n"; //     ,    .
    Comment(sComment);
    //====    . ===============================================================================================================================================================================================
    nAdr = 0;
    sComment = sComment + "   BOOL: ("              + string(MemoryWriteBoolW(Area, sPrefix, Index, NameMemory0, nAdr, bValue)) + ")  " + string(bValue) + "\n";
    nAdr++;
    sComment = sComment + "   CHAR: ("              + string(MemoryWriteCharW(Area, sPrefix, Index, NameMemory0, nAdr, cValue)) + ")  " + string(cValue) + "\n";
    nAdr++;
    sComment = sComment + "   UCHAR: ("             + string(MemoryWriteUCharW(Area, sPrefix, Index, NameMemory0, nAdr, ucValue)) + ")  " + string(ucValue) + "\n";
    nAdr++;
    sComment = sComment + "   SHORT: ("             + string(MemoryWriteShortW(Area, sPrefix, Index, NameMemory0, nAdr, shValue)) + ")  " + string(shValue) + "\n";
    nAdr += 2;
    sComment = sComment + "   USHORT: ("            + string(MemoryWriteUShortW(Area, sPrefix, Index, NameMemory0, nAdr, ushValue)) + ")  " + string(ushValue) + "\n";
    nAdr += 2;
    sComment = sComment + "   INT: ("               + string(MemoryWriteIntW(Area, sPrefix, Index, NameMemory0, nAdr, nValue)) + ")  " + string(nValue) + "\n";
    nAdr += 4;
    sComment = sComment + "   FLOAT: ("             + string(MemoryWriteFloatW(Area, sPrefix, Index, NameMemory0, nAdr, fValue)) + ")  " + string(fValue) + "\n";
    nAdr += 4;
    sComment = sComment + "   DOUBLE: ("            + string(MemoryWriteDoubleW(Area, sPrefix, Index, NameMemory0, nAdr, dValue)) + ")  " + string(dValue) + "\n";
    nAdr += 8;
    sComment = sComment + "   STRING (ANSI): ("    + string(MemoryWriteStringUnicodeToAnsiW(Area, sPrefix, Index, NameMemory0, nAdr, sValue0)) + ")  \"" + sValue0 + "\"\n";
    nAdr += nSize0;
    sComment = sComment + "   STRING (UNICODE): (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, nAdr, sValue1)) + ")  \"" + sValue1 + "\"\n";
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 2 * nSize1; //   UNICODE-.        .
    sComment = sComment + "   BOOL: (" + string(MemoryWriteBoolArrayW(Area, sPrefix, Index, NameMemory0, nAdr, abOutArray, ArraySize(abOutArray), 0, ArraySize(abOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(abOutArray[i]) + ", ";
      else sComment = sComment + string(abOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   CHAR: (" + string(MemoryWriteCharArrayW(Area, sPrefix, Index, NameMemory0, nAdr, acOutArray, ArraySize(acOutArray), 0, ArraySize(acOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(acOutArray[i]) + ", ";
      else sComment = sComment + string(acOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   UNSIGNED CHAR: (" + string(MemoryWriteUCharArrayW(Area, sPrefix, Index, NameMemory0, nAdr, aucOutArray, ArraySize(aucOutArray), 0, ArraySize(aucOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aucOutArray[i]) + ", ";
      else sComment = sComment + string(aucOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   SHORT: (" + string(MemoryWriteShortArrayW(Area, sPrefix, Index, NameMemory0, nAdr, ashOutArray, ArraySize(ashOutArray), 0, ArraySize(ashOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(ashOutArray[i]) + ", ";
      else sComment = sComment + string(ashOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   UNSIGNED SHORT: (" + string(MemoryWriteUShortArrayW(Area, sPrefix, Index, NameMemory0, nAdr, aushOutArray, ArraySize(aushOutArray), 0, ArraySize(aushOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aushOutArray[i]) + ", ";
      else sComment = sComment + string(aushOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   INT: (" + string(MemoryWriteIntArrayW(Area, sPrefix, Index, NameMemory0, nAdr, aiOutArray, ArraySize(aiOutArray), 0, ArraySize(aiOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aiOutArray[i]) + ", ";
      else sComment = sComment + string(aiOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   FLOAT: (" + string(MemoryWriteFloatArrayW(Area, sPrefix, Index, NameMemory0, nAdr, afOutArray, ArraySize(afOutArray), 0, ArraySize(afOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(afOutArray[i]) + ", ";
      else sComment = sComment + string(afOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    nAdr += 50;
    sComment = sComment + "   DOUBLE: (" + string(MemoryWriteDoubleArrayW(Area, sPrefix, Index, NameMemory0, nAdr, adOutArray, ArraySize(adOutArray), 0, ArraySize(adOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(adOutArray[i]) + ", ";
      else sComment = sComment + string(adOutArray[i]);
     }
    sComment = sComment + "}\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //====       . =============================================================================================================================================================
    sComment = sComment + "   : (" + string(MemoryUnProjectionW(Area, sPrefix, Index, "", stAddress)) + ")\n"; //    3- .
//    sComment = sComment + "   : (" + string(MemoryUnProjectionW(Area, sPrefix, Index, NameMemory0, NULL)) + ")\n";
    Comment(sComment);
   }
  //xxxx   ,      . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  //   ,          4,     ,    .     .
  if (CheckRead)
   {//====       . =========================================================================================================================================================================
//    stAddress = MemoryCreateProjectionW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize);
//    sComment = sComment + "   \"" + NameMemory0 + "\"  . : " + string(stAddress) + "\n\n";
//    Comment(sComment);
    //====   . ===============================================================================================================================================================================================
    hMapping = MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize); //  .   ,  .       .
    sComment = sComment + " \"" + NameMemory0 + "\" . : " + string(hMapping) + "\n";
    Comment(sComment);
    Sleep(3000);
    //====         . ====================================================================================================================================
//    stAddress = MemoryProjectionW(Area, sPrefix, hMapping);
//    sComment = sComment + "      \"" + NameMemory0 + "\". : " + string(stAddress) + "\n\n";
//    Comment(sComment);
    while (CheckRead && !IsStopped())
     {//====     . ===================================================================================================================================================================================
      ArrayInitialize(abIncArray, 0);
      ArrayInitialize(acIncArray, 0);
      ArrayInitialize(aucIncArray, 0);
      ArrayInitialize(ashIncArray, 0);
      ArrayInitialize(aushIncArray, 0);
      ArrayInitialize(aiIncArray, 0);
      ArrayInitialize(afIncArray, 0);
      ArrayInitialize(adIncArray, 0);
      //====         . ==================================================================================================================================
      stAddress = MemoryProjectionByHandleW(Area, sPrefix, -1, hMapping);
      sComment = sComment + "      \"" + NameMemory0 + "\". : " + string(stAddress) + "\n\n";
      Comment(sComment);
      //====    . =============================================================================================================================================================================================
      nAdr = 0;
      sComment = sComment + "   BOOL: "                + string(MemoryReadBoolW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr++;
      sComment = sComment + "   CHAR: "                + string(MemoryReadCharW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr++;
      sComment = sComment + "   UNSIGNED CHAR: "       + string(MemoryReadUCharW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr++;
      sComment = sComment + "   SHORT: "               + string(MemoryReadShortW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr += 2;
      sComment = sComment + "   UNSIGNED SHORT: "      + string(MemoryReadUShortW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr += 2;
      sComment = sComment + "   INT: "                 + string(MemoryReadIntW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr += 4;
      sComment = sComment + "   FLOAT: "               + string(MemoryReadFloatW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr += 4;
      sComment = sComment + "   DOUBLE: "              + string(MemoryReadDoubleW(Area, sPrefix, Index, NameMemory0, nAdr)) + "\n";
      nAdr += 8;
      sComment = sComment + "   STRING (ANSI): \""    + string(MemoryReadStringAnsiToUnicodeW(Area, InitPrefix, Index, NameMemory0, nAdr, nSize0)) + "\"\n";
      nAdr += nSize0;
      sComment = sComment + "   STRING (UNICODE): \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, nAdr, nSize1)) + "\"\n";
      //         .      50 .    .     .
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 2 * nSize1; //   UNICODE-.        .
      sComment = sComment + "   BOOL: (" + string(MemoryReadBoolArrayW(Area, sPrefix, Index, NameMemory0, nAdr, abIncArray, ArraySize(abIncArray), 0, ArraySize(abIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(abIncArray[i]) + ", ";
        else sComment = sComment + string(abIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   CHAR: (" + string(MemoryReadCharArrayW(Area, sPrefix, Index, NameMemory0, nAdr, acIncArray, ArraySize(acIncArray), 0, ArraySize(acIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(acIncArray[i]) + ", ";
        else sComment = sComment + string(acIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   UNSIGNED CHAR: (" + string(MemoryReadUCharArrayW(Area, sPrefix, Index, NameMemory0, nAdr, aucIncArray, ArraySize(aucIncArray), 0, ArraySize(aucIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(aucIncArray[i]) + ", ";
        else sComment = sComment + string(aucIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   SHORT: (" + string(MemoryReadShortArrayW(Area, sPrefix, Index, NameMemory0, nAdr, ashIncArray, ArraySize(ashIncArray), 0, ArraySize(ashIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(ashIncArray[i]) + ", ";
        else sComment = sComment + string(ashIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   UNSIGNED SHORT: (" + string(MemoryReadUShortArrayW(Area, sPrefix, Index, NameMemory0, nAdr, aushIncArray, ArraySize(aushIncArray), 0, ArraySize(aushIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(aushIncArray[i]) + ", ";
        else sComment = sComment + string(aushIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   INT: (" + string(MemoryReadIntArrayW(Area, sPrefix, Index, NameMemory0, nAdr, aiIncArray, ArraySize(aiIncArray), 0, ArraySize(aiIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(aiIncArray[i]) + ", ";
        else sComment = sComment + string(aiIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   FLOAT: (" + string(MemoryReadFloatArrayW(Area, sPrefix, Index, NameMemory0, nAdr, afIncArray, ArraySize(afIncArray), 0, ArraySize(afIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(afIncArray[i]) + ", ";
        else sComment = sComment + string(afIncArray[i]);
       }
      sComment = sComment + "}\n";
      Comment(sComment);
      //----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      nAdr += 50;
      sComment = sComment + "   DOUBLE: (" + string(MemoryReadDoubleArrayW(Area, sPrefix, Index, NameMemory0, nAdr, adIncArray, ArraySize(adIncArray), 0, ArraySize(adIncArray))) + ")  {";
      for (i = 0; i < 10; i++)
       {
        if (i < 9) sComment = sComment + string(adIncArray[i]) + ", ";
        else sComment = sComment + string(adIncArray[i]);
       }
      sComment = sComment + "}\n\n";
      Comment(sComment);
      //====       . ===========================================================================================================================================================
      sComment = sComment + "   : (" + string(MemoryUnProjectionW(Area, sPrefix, Index, "", stAddress)) + ")\n"; //    3- .
//    sComment = sComment + "   : (" + string(MemoryUnProjectionW(Area, sPrefix, Index, NameMemory0, NULL)) + ")\n";
      Comment(sComment);
      Sleep(2000);
      sComment = "";
     }
    //====       . =============================================================================================================================================================
//    sComment = sComment + "   : (" + string(MemoryUnProjectionW(Area, sPrefix, Index, "", stAddress)) + ")\n"; // 
//    Comment(sComment);
    //====     . ====================================================================================================================================================================================
    sComment = sComment + "   \"" + NameMemory0 + "\"  : (" + string(MemoryCloseNameW(Area, sPrefix, NameMemory0)) + ")\n";
    Comment(sComment);
    sComment = sComment + " . : " + string(MemoryOpenProjectionW(Area, sPrefix, Index, NameMemory0)) + "\n\n";
    Comment(sComment);
   }
  //xxxx   . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  //  !       -   . ,     .
  if (CheckGeneral)
   {//====   . ====================================================================================================================================================================================================
    sComment = sComment + "1.  \"" + NameMemory1 + "\" . : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory1, MemorySize)) + "\n";
    Comment(sComment);
    sComment = sComment + "2.  \"" + NameMemory2 + "\" . : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory2, MemorySize)) + "\n";
    Comment(sComment);
    sComment = sComment + "1.  \"" + NameMemory1 + "\" . : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory1)) + "\n";
    Comment(sComment);
    sComment = sComment + "2.  \"" + NameMemory2 + "\" . : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory2)) + "\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n";
    Comment(sComment);
    sComment = sComment + "1.  .    \"" + NameMemory1 + "\". : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory1)) + "\n";
    Comment(sComment);
    sComment = sComment + "2.  .    \"" + NameMemory2 + "\". : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory2)) + "\n\n";
    Comment(sComment);
    //====     . ==============================================================================================================================================================================
    sComment = sComment + "1. \"" + NameMemory1 + "\" . : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory1, MemorySize)) + "\n";
    Comment(sComment);
    sComment = sComment + "2. \"" + NameMemory2 + "\" . : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory2, MemorySize)) + "\n";
    Comment(sComment);
    sComment = sComment + "    : (" + string(MemoryCloseHandleFileW(Area, sPrefix, NULL)) + ")\n";
    Comment(sComment);
    sComment = sComment + "1.  .    \"" + NameMemory1 + "\". : " + string(MemoryOpenW(Area, sPrefix, Index,  NameMemory1)) + "\n";
    Comment(sComment);
    sComment = sComment + "2.  .    \"" + NameMemory2 + "\". : " + string(MemoryOpenW(Area, sPrefix, Index,  NameMemory2)) + "\n\n";
    Comment(sComment);
    //====    . ================================================================================================================================================================================================
    sComment = sComment + "1. \"" + NameMemory0 + "\" . : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize)) + "\n";
    Comment(sComment);
    sComment = sComment + "2. \"" + NameMemory0 + "\" . : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize)) + "\n";
    Comment(sComment);
    sComment = sComment + "    : (" + string(MemoryCloseNameW(Area, sPrefix, NameMemory0)) + ")\n";
    Comment(sComment);
    sComment = sComment + " .   . : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory0)) + "\n\n";
    Comment(sComment);
    //====   . . =================================================================================================================================================================================================
    //    .      .
    hMapping1 = MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory1, MemorySize);
    sComment = sComment + "1. \"" + NameMemory1 + "\" . : " + string(hMapping1) + "\n";
    Comment(sComment);
    hMapping2 = MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory2, MemorySize);
    sComment = sComment + "2. \"" + NameMemory2 + "\" . : " + string(hMapping2) + "\n";
    Comment(sComment);
    hMapping3 = MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory3, MemorySize);
    sComment = sComment + "3. \"" + NameMemory3 + "\" . : " + string(hMapping3) + "\n";
    Comment(sComment);
    hMapping4 = MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory4, MemorySize);
    sComment = sComment + "4. \"" + NameMemory4 + "\" . : " + string(hMapping4) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "    \"" + NameMemory2 + "\".  = " + string(MemoryIndexByNameW(Area, sPrefix, NameMemory2)) + "\n";
    Comment(sComment);
    sComment = sComment + "     3.  : " + MemoryUserNameByIndexW(Area, sPrefix, 3) + "\n";
    Comment(sComment);
    sComment = sComment + "     3.  : " + MemoryFullNameByIndexW(Area, sPrefix, 3) + "\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "1.   1  STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory1, StartByte, sValue1)) + ")  \"" + sValue1 + "\"\n";
    Comment(sComment);
    sComment = sComment + "2.   2  STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory2, StartByte, sValue2)) + ")  \"" + sValue2 + "\"\n";
    Comment(sComment);
    sComment = sComment + "3.   3  STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory3, StartByte, sValue3)) + ")  \"" + sValue3 + "\"\n";
    Comment(sComment);
    sComment = sComment + "4.   4  STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory4, StartByte, sValue4)) + ")  \"" + sValue4 + "\"\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "1.   1  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory1, StartByte, nSize1)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "2.   2  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory2, StartByte, nSize2)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "3.   3  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory3, StartByte, nSize3)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "4.   4  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory4, StartByte, nSize4)) + "\"\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "    (" + NamePrefix + ")  : (" + string(MemoryCloseAllW(Area, sPrefix, NamePrefix)) + ")\n";
    Comment(sComment);
//    Sleep(30000);
//    sComment = sComment + " : (" + MemoryCloseHandle(Area, sPrefix, hMapping2) + ")\n";
//    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "1.  .   1  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory1, StartByte, nSize1)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "2.  .   2  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory2, StartByte, nSize2)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "3.  .   3  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory3, StartByte, nSize3)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "4.  .   4  STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory4, StartByte, nSize4)) + "\"\n";
    Comment(sComment);
//    Sleep(300000);
    sComment = sComment + " : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n\n";
    Comment(sComment);
    //====   . . ================================================================================================================================================================================================
    //       .       .
    sComment = sComment + "   CHAR: (" + string(MemoryWriteCharArrayW(Area, sPrefix, Index, NameMemory1, StartByte, acOutArray, ArraySize(acOutArray), 0, ArraySize(acOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(acOutArray[i]) + ", ";
      else sComment = sComment + string(acOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   SHORT: (" + string(MemoryWriteShortArrayW(Area, sPrefix, Index, NameMemory2, StartByte, ashOutArray, ArraySize(ashOutArray), 0, ArraySize(ashOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(ashOutArray[i]) + ", ";
      else sComment = sComment + string(ashOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   INT: (" + string(MemoryWriteIntArrayW(Area, sPrefix, Index, NameMemory3, StartByte, aiOutArray, ArraySize(aiOutArray), 0, ArraySize(aiOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aiOutArray[i]) + ", ";
      else sComment = sComment + string(aiOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    sComment = sComment + "   DOUBLE: (" + string(MemoryWriteDoubleArrayW(Area, sPrefix, Index, NameMemory4, StartByte, adOutArray, ArraySize(adOutArray), 0, ArraySize(adOutArray))) + ")  {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(adOutArray[i]) + ", ";
      else sComment = sComment + string(adOutArray[i]);
     }
    sComment = sComment + "}\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "    (" + NamePrefix + ")  : (" + string(MemoryCloseAllW(Area, sPrefix, NamePrefix)) + ")\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    sComment = sComment + "   CHAR: (" + string(MemoryReadCharArrayW(Area, sPrefix, Index, NameMemory1, StartByte, acIncArray, ArraySize(acIncArray), 0, ArraySize(acIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(acIncArray[i]) + ", ";
      else sComment = sComment + string(acIncArray[i]) + "}\n";
     }
    Comment(sComment);
    sComment = sComment + "   SHORT: (" + string(MemoryReadShortArrayW(Area, sPrefix, Index, NameMemory2, StartByte, ashIncArray, ArraySize(ashIncArray), 0, ArraySize(ashIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(ashIncArray[i]) + ", ";
      else sComment = sComment + string(ashIncArray[i]) + "}\n";
     }
    Comment(sComment);
    sComment = sComment + "   INT: (" + string(MemoryReadIntArrayW(Area, sPrefix, Index, NameMemory3, StartByte, aiIncArray, ArraySize(aiIncArray), 0, ArraySize(aiIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(aiIncArray[i]) + ", ";
      else sComment = sComment + string(aiIncArray[i]) + "}\n";
     }
    Comment(sComment);
    sComment = sComment + "   DOUBLE: (" + string(MemoryReadDoubleArrayW(Area, sPrefix, Index, NameMemory4, StartByte, adIncArray, ArraySize(adIncArray), 0, ArraySize(adIncArray))) + ")        {";
    for (i = 0; i < 10; i++)
     {
      if (i < 9) sComment = sComment + string(adIncArray[i]) + ", ";
      else sComment = sComment + string(adIncArray[i]) + "}\n";
     }
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    // !!!         .  .   ,  .    4096 .        ,  .
    sComment = sComment + " : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n\n";
    Comment(sComment);
    //====   . ================================================================================================================================================================================================
    sComment = sComment + "  \"" + NameMemory0 + "\". : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, 10)) + "\n";
    Comment(sComment);
    sComment = sComment + "  : " + string(MemorySizeW(Area, sPrefix, Index, NameMemory0)) + "\n";
    Comment(sComment);
    //    .
    sComment = sComment + "   STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, StartByte, sValue0)) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    //         .              .
    sComment = sComment + "   STRING:             \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte + 20, nSize0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : " + string(MemorySizeW(Area, sPrefix, Index, NameMemory0)) + "\n"; //   : 21 - 1 + 21 = 41
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryResizeW(Area, sPrefix, Index, NameMemory0, 50)) + ")\n";
    Comment(sComment);
    sComment = sComment + "  : " + string(MemorySizeW(Area, sPrefix, Index, NameMemory0)) + "\n";
    Comment(sComment);
    sComment = sComment + "   STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, StartByte + 20, sValue0)) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte, 50)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n";
    Comment(sComment);
    //====   . =====================================================================================================================================================================================================
    sComment = sComment + "  \"" + NameMemory0 + "\". : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, 1000)) + "\n";
    Comment(sComment);
    sComment = sComment + "   STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, StartByte, sValue0)) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte, nSize0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryClearW(Area, sPrefix, Index, NameMemory0)) + ")\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte, nSize0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n\n";
    Comment(sComment);
    //====      . =====================================================================================================================================================================================
    sComment = sComment + "  \"" + NameMemory0 + "\". : " + string(MemoryCreateW(Area, sPrefix, NULL, Index, NameMemory0, 10)) + "\n";
    Comment(sComment);
    sComment = sComment + "    \"" + NameMemory0 + "\": (" + string(MemoryCheckNameW(Area, sPrefix, NameMemory0)) + ")\n";
    Comment(sComment);
    sComment = sComment + "    \"" + NameMemory1 + "\": (" + string(MemoryCheckNameW(Area, sPrefix, NameMemory1)) + ")\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n";
    Comment(sComment);
    sComment = sComment + "    \"" + NameMemory0 + "\": (" + string(MemoryCheckNameW(Area, sPrefix, NameMemory0)) + ")\n";
    Comment(sComment);
    sComment = sComment + "    \"" + NameMemory1 + "\": (" + string(MemoryCheckNameW(Area, sPrefix, NameMemory1)) + ")\n\n";
    Comment(sComment);
    //====     . =================================================================================================================================================================================
    sComment = sComment + "   STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, StartByte, sValue0)) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   : (" + string(MemorySetW(Area, sPrefix, Index, NameMemory0, 3, 'G', 6)) + ")\n";
    Comment(sComment);
    sComment = sComment + "   STRING:             \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte, nSize0)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryCloseAllW(Area, sPrefix, "")) + ")\n\n";
    Comment(sComment);
    //------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   }
  //xxxx  . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckProjection)
   {//====   . ===============================================================================================================================================================================================
    stAddress = MemoryCreateProjectionW(Area, sPrefix, NULL, Index, NameMemory0, MemorySize); //  .
    sComment = sComment + "   : " + string(MemoryClearW(Area, sPrefix, Index, NameMemory0)) + "\n"; //     ,    .
    Comment(sComment);
    sComment = sComment + " \"" + NameMemory0 + "\" . : " + string(stAddress) + "\n";
    Comment(sComment);
    sComment = sComment + "   STRING: (" + string(MemoryWriteStringW(Area, sPrefix, Index, NameMemory0, 0, sValue0)) + ")  \"" + sValue0 + "\"\n";
    Comment(sComment);
    sComment = sComment + "   STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, 0, 50)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "   : (" + string(MemorySetW(Area, sPrefix, Index, NameMemory0, 'X', 5, 8)) + ")\n";
    Comment(sComment);
    sComment = sComment + "   STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, 0, 50)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "  : (" + string(MemoryClearW(Area, sPrefix, Index, NameMemory0)) + ")\n";
    Comment(sComment);
    sComment = sComment + "   STRING: \"" + string(MemoryReadStringW(Area, sPrefix, Index, NameMemory0, 0, 50)) + "\"\n";
    Comment(sComment);
    sComment = sComment + "   : (" + string(MemoryUnProjectionW(Area, sPrefix, Index, NameMemory0, NULL)) + ")\n"; //    .
    Comment(sComment);
    sComment = sComment + "    : (" + string(MemoryCloseNameW(Area, sPrefix, NameMemory0)) + ")\n"; //       .
    Comment(sComment);
    sComment = sComment + " .   . : " + string(MemoryOpenW(Area, sPrefix, Index, NameMemory0)) + "\n\n";
    Comment(sComment);
   }
  //xxxx       . xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  if (CheckClose)
   {//====   . ====================================================================================================================================================================================================
    sComment = sComment + "   STRING: \"" + MemoryReadStringW(Area, sPrefix, Index, NameMemory0, StartByte, StringLen(sValue0)) + "\"\n";
    Comment(sComment);
//    sComment = sComment + "     0: " + MemoryFullNameByIndexW(Area, sPrefix, 0) + "\n";
//    Comment(sComment);
//    sComment = sComment + "  : (" + MemoryCloseAllW(Area, sPrefix, "") + ")\n\n";
//    Comment(sComment);
//    sComment = sComment + "    : (" + MemoryCloseHandleFileW(Area, sPrefix, NULL) + ")\n";
//    Comment(sComment);
//    sComment = sComment + "  : (" + MemoryClearW(Area, sPrefix, Index, NameMemory0) + ")\n";
//    Comment(sComment);
//    sComment = sComment + "    : (" + MemoryCloseNameW(Area, sPrefix, NameMemory0) + ")\n";
//    Comment(sComment);
//    sComment = sComment + "  : " + MemorySizeW(Area, sPrefix, Index, NameMemory0) + "\n"; //   : 21 - 1 + 21 = 41
//    Comment(sComment);
   }
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 }
//